PROGRAM WOLFEDIT;
    { Werewolf II's Player Databases Editor Source Code.       }
    { Covers 2 database files:  WOLFPLAY.DAT and WOLFCORP.DAT. }

USES CRT, GoldWin, GoldFast, GoldRead, GoldMisc,
     LordLock, ChasWare;

     {$I WereVars.inc}

    { WereWolf II v1.00 and WolfEdit v1.10 released on 10/31/2007. }
{ ================================================================= }

CONST Version = 'v1.10';
            {07/12/07: Changed to v1.10. Non-Beta}

      {   Compile_Date: STRING = 'October 31, 2007.';   }  {disabled 10/23/07}

      Release_Date: STRING = 'October 31th, 2007.';  {07/12/07}
      { ================================================== }

      CFGName: STRING = 'WOLFEDIT.CFG';

      WolfPlayer_FN = 'WOLFPLAY.DAT';

      RealName   = '1';     LordName    = '2';    PlayNum     = '3';
      Visits     = '4';     Wisdom      = '5';    HitMax      = '6';
      Strength   = '7';     Defense     = '8';    Charm       = '9';
      Gems       = '0';     Kids_Killed = 'A';    Horse_Kills = 'B';
      Human_Kills= 'C';     Attacks     = 'D';    Rescue      = 'E';  {02/10/07}
      { ================================================================= }

      WolfCorpse_FN = 'WOLFCORP.DAT';       {Added for editing WOLFCORP.DAT file 12/27/05}

      RecNum    = 'K';      RealName2 = 'L';
      LordName2 = 'M';      Desecrations = 'N';

      TwoBillion: LongInt = 2000000000;

         { Q - Quit/Save Changes.   X - Player Search.  }
         { * - New Day for Player.                      }
    { ======================================================== }

VAR TSearch: Wolf_Player;   { for player searches }

    TWEdit:  Wolf_Player;   { for viewing/editing database records }

    WolfPlay_FN: STRING;      { File Vars for WOLFPLAY.DAT access }

    IGMDir: STRING;

    ProgPath: STRING;

    Editor_File: FILE OF Wolf_Player;

    RecordNum  : BYTE;

    DebugVar: BOOLEAN;  {Added 02/28/07}

      { TempNum, Used, Found: Accessed from WereVars.inc. }
      { Used in record Seek process.  }

    { -------------------- Added 12/27/2005: --------------------------- }
    TSearch2: Desecrations_Player;  {For Player Searches of WOLFCORP.DAT}
    TCEdit:  Desecrations_Player;

    Corpse_FN: STRING;  {File VARs for WOLFCORP.DAT access}

    Corpse_File: FILE OF Desecrations_Player;

    Corpse_Number: BYTE;

    Editor_Code: BYTE;  {1 - WOLFPLAY.DAT editor.  2 - WOLFCORP.DAT editor }
    { ======================================================= }


PROCEDURE ReadConfig;           {VERIFIED 12/27/05}
VAR  Config_File : TEXT;  {07/15/05: Changed F to Config_File.}

  PROCEDURE MakeConfig;
      VAR IgmLoc: STRING;  {07/15/05: Changed string[80] to String.}
  BEGIN                       {Changed value from 20 to 60. 07/15/05}
    IgmLoc:= PromptStr(0,0,60,'Enter directory path to Werewolf IGM',' Installation ','',False);
       { No way seen to put the input data field on a separate line inside dialog box. }

    Addtext(AddBack(IgmLoc),CfgName,True);
  END;   { ============================================================- }

BEGIN           {CfgName value at this point: WOLFEDIT.CFG}
  IF NOT Exist(CfgName) THEN MakeConfig;

  ASSIGN(Config_File,ProgPath+CfgName);
     { added Progpath 07/15/05: Fixed problem where compiler would not run WOLFEDIT properly.}

  RESET(Config_File);
  Readln(Config_File,IgmDir);
  CLOSE(Config_File);

  { Verified that IGMDir value is known at this point 6:41 am 07/15/05 }

  IF IGMDir = ' ' THEN IGMDir:= ProgPath;  {07/15/05: just in case of error code}

END;       { ================================================== }


PROCEDURE READ_WOLVES_FILE;  { Reads the IGM's WOLFPLAY.DAT file. }    {VERIFIED 12/27/05}
BEGIN
  IF IGMDir <> ' ' THEN WolfPlay_FN:= IgmDir+WolfPlayer_FN  {07/15/05: insurance code}
                   ELSE WolfPlay_FN:= WolfPlayer_FN;

  ASSIGN(Editor_File,WolfPlay_FN);   {07/29/05: Renamed WolfPlay_FN to Wolf_FN.}
  Lockfile(WolfPlay_FN);             {04/04/06: Changed Wolf_FN back to WolfPlay_FN.}
  RESET(Editor_File);

  SEEK(Editor_File,RecordNum);

  READ(Editor_File,TWEdit);

  UnLockFile(WolfPlay_FN);
  CLOSE(Editor_File);
END;     { READ_WOLVES_FILE ================================================== }


PROCEDURE SEARCH_PLAYER(Num:Integer);      {VERIFIED 12/27/05}
      { Reads WOLFPLAY.DAT. Does search on player record number }
BEGIN
  WolfPlay_FN:= IgmDir+WolfPlayer_FN;      {07/29/05}

  ASSIGN(Editor_File,WolfPlay_FN);
  Lockfile(WolfPlay_FN);
  RESET(Editor_File);

  SEEK(Editor_File,Num);
  READ(Editor_File,TSearch);

  UnLockFile(WolfPlay_FN);
  CLOSE(Editor_File);
END;     { Search_Player  ============================================ }


  { Reads WOLFCORP.DAT. Does Search on player record number }
PROCEDURE SEARCH_CORPSES(Num:Integer);  {Created 12/27/05}
BEGIN
  Corpse_FN:= IgmDir+WolfCorpse_FN;      {07/29/05}

  ASSIGN(Corpse_File,Corpse_FN);
  Lockfile(Corpse_FN);
  RESET(Corpse_File);

  SEEK(Corpse_File,Num);
  READ(Corpse_File,TSearch2);

  UnLockFile(Corpse_FN);
  CLOSE(Corpse_File);
END;     { SEARCH_CORPSES  ================================ }


PROCEDURE READ_CORPSES_FILE;  {Created 12/27/05: VERIFIED 12/27/05}
BEGIN                { Reads the IGM's WOLFCORP.DAT file. }
  IF IGMDir <> ' ' THEN Corpse_FN:= IgmDir+WolfCorpse_FN
                   ELSE Corpse_FN:= WolfCorpse_FN;

  ASSIGN(Corpse_File,Corpse_FN);
  Lockfile(Corpse_FN);
  RESET(Corpse_File);

  SEEK(Corpse_File,Corpse_Number);

  READ(Corpse_File,TCEdit);

  UnLockFile(Corpse_FN);
  CLOSE(Corpse_File);
END;     { READ_CORPSES_FILE ================================================== }


FUNCTION Get(b:CHAR):STRING;                         {VERIFIED 12/27/05}
BEGIN
  CASE UpCase(b) OF
    RealName : Get:='`!'+TWEdit.RealName;

    LordName : Get:='`$'+TWEdit.LordName;

    PlayNum  : Get:='`@'+N2S(TWEdit.PlayNum);

    Visits   : IF TWEdit.Visits = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+N2S(TWEdit.Visits);

    Wisdom   : IF TWEdit.Wisdom = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+COMMA(TWEdit.Wisdom);

    HitMax   : IF TWEdit.HitMax = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+COMMA(TWEdit.HitMax);

    Strength : IF TWEdit.Strength = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+COMMA(TWEdit.Strength);

    Defense  : IF TWEdit.Defense = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+COMMA(TWEdit.Defense);

    Charm    : IF TWEdit.Charm = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+COMMA(TWEdit.Charm);

    Gems     : IF TWEdit.Gems = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+COMMA(TWEdit.Gems);

    Kids_Killed : IF TWEdit.Kids_Killed = 0              {Revised/Verified 07/30/05}
                    THEN  Get:= '`#None'
                    ELSE  Get:= '`$'+COMMA(TWEdit.Kids_Killed);

    Horse_Kills : IF TWEdit.Horse_Kills = 0              {Revised/Verified 07/30/05}
                    THEN  Get:= '`#None'
                    ELSE  Get:= '`$'+COMMA(TWEdit.Horse_Kills);

    Human_Kills : IF TWEdit.Human_Kills = 0              {Revised/Verified 07/30/05}
                    THEN  Get:= '`#None'
                    ELSE  Get:= '`$'+COMMA(TWEdit.Human_Kills);

    Attacks     : IF TWEdit.Attacks = 0              {Revised/Verified 07/30/05}
                    THEN  Get:= '`#None'
                    ELSE  Get:= '`$'+COMMA(TWEdit.Attacks);

    Rescue      : IF TWEdit.Fairy_Rescue     {Added 02/10/07}     {verified 02/10/07}
						 THEN Get:= '`$Yes! ' ELSE Get:= '`#Nope!';
  END;  {CASE}

  CursorOff;   {06/25/06: needed to fix bug found by Dennis Collins.}
    { When program's user would change a setting in a dialog box, when }
    { they returned to the main screen, the cursor would be back on the }
    { screen, so this keeps the cursor deactivated while the editor runs. }
END;   { GET Func. ============================================= }


FUNCTION Get2(b:CHAR):STRING;     {Created 12/27/05: VERIFIED 12/27/05}
BEGIN
  CASE UpCase(b) OF
    RecNum    : Get2:='`!'+N2S(TCEdit.RecNum);

    RealName2 : Get2:='`!'+TCEdit.RealName;

    LordName2 : Get2:='`$'+TCEdit.LordName;

    Desecrations : Get2:='`@'+N2S(TCEdit.Desecrations);
  END;  {CASE}

  CursorOff;   {06/25/06: needed to fix bug found by Dennis Collins.}
    { When program's user would change a setting in a dialog box, when }
    { they returned to the main screen, the cursor would be back on the }
    { screen, so this keeps the cursor deactivated while the editor runs. }
END;   { GET2 Func. =================================== }


PROCEDURE WRITE_WOLVES_FILE; { Writes IGM's WOLFPLAY.DAT file }
BEGIN                                      {VERIFIED 12/27/05}
  WolfPlay_FN:= IgmDir+WolfPlayer_FN;  {07/29/05}

  ASSIGN(Editor_File,WolfPlay_FN);
  LOCKFILE(WolfPlay_FN);
  RESET(Editor_File);

  SEEK(Editor_File,RecordNum);
  WRITE(Editor_File,TWEdit);

  UNLOCKFILE(WolfPlay_FN);
  CLOSE(Editor_File);
END;     { WRITE_WOLVES_FILE   =============================== }


                  {Created 12/27/05: VERIFIED 12/27/05}
PROCEDURE WRITE_CORPSES_FILE; { Writes IGM's WOLFCORP.DAT file }
BEGIN
  Corpse_FN:= IgmDir+WolfCorpse_FN;

  ASSIGN(Corpse_File,Corpse_FN);
  LOCKFILE(Corpse_FN);
  RESET(Corpse_File);

  SEEK(Corpse_File,Corpse_Number);
  WRITE(Corpse_File,TCEdit);

  UNLOCKFILE(Corpse_FN);
  CLOSE(Corpse_File);
END;     { WRITE_CORPSES_FILE   =============================== }


{ 1  }PROCEDURE Do_RealName;          {VERIFIED 07/15/05}
BEGIN
  TWEdit.RealName:=
   PromptStr(0,0,50,'Enter REAL name for player',' Player Real Name Change ',TWEdit.RealName,False);
       { 09/01/05: renamed Real_Names to RealName. }

  WRITE_WOLVES_FILE;
  CWriteXy(25,4,Replicate(50,' '));  { Write data on position 25, Line #4. }
  CWriteXy(25,4,Get(RealName));
END;


{ 2  }PROCEDURE Do_LordName;           {VERIFIED 07/15/05}
BEGIN
  TWEdit.LordName:=
   PromptStr(0,0,20,'Enter LORD Name for player',' Player Lord Name Change ',TWEdit.LordName,False);

  WRITE_WOLVES_FILE;
  CwriteXY(25,5,Replicate(20,' '));
  CwriteXY(25,5,Get(LordName));     { Write data on position 25, Line #5. }
END;


   { In normal usage, don't allow users to change LORD Player Numbers. }
   { 02/28/07: Renamed DO_PlayNum to DO_PLAYER_NUMBER. }
                                                       
{ 3  }PROCEDURE DO_PLAYER_NUMBER;            {VERIFIED 07/15/05}
BEGIN
  TWEdit.PlayNum:=
   PromptNum(0,0,'Enter player''s LORD Player # (0-160)?',' LORD Player Number Change ',TWEdit.PlayNum,0,160,True);

  WRITE_WOLVES_FILE;
  CWriteXy(25,6,Replicate(5,' '));    { Allow room for 3 digits, and 2 blank spaces. 07/13/05}
  CWriteXy(25,6,Get(PlayNum));         { Write Player Number data, Line #6, column #2. 07/13/05 }
END;


{ 4  }PROCEDURE Do_Visits;               {VERIFIED 07/15/05}
BEGIN
  TWEdit.Visits:=
   PromptNum(0,0,'Enter # of Visits Today (0-10)?',' Visits Change ',TWEdit.Visits,0,10,True);

  WRITE_WOLVES_FILE;
  CWriteXy(57,6,Replicate(4,' '));    { Allow room for 2 digits, and 2 blank spaces. 07/13/05}
  CWriteXy(57,6,Get(Visits));         { Write Visits data, Line #6, column #1. 07/11/05 }
END;


{ 5  }PROCEDURE Do_Wisdom;             {Revised 09/30/05}
BEGIN
  TWEdit.Wisdom:=
  PromptNum(0,0,'Enter Wisdom Points (0-500 Million)?',' Wisdom Points Change ',TWEdit.Wisdom,0,500000000,True);

  WRITE_WOLVES_FILE;
  CwriteXY(25,7,Replicate(11,' '));  {Covers use of commas}
  CwriteXY(25,7,Get(Wisdom));
END;


{ 6  }PROCEDURE Do_HitMax;              {VERIFIED 07/15/05}
BEGIN
  TWEdit.HitMax:=
  PromptNum(0,0,'Enter Max Hit-Points (0-32000)?',' Max Hit-Points Change ',TWEdit.HitMax,0,32000,True);

  WRITE_WOLVES_FILE;
  CwriteXY(25,8,Replicate(13,' '));   {Covers use of commas}
  CwriteXY(25,8,Get(HitMax));
END;


{ 7  }PROCEDURE Do_Strength;             {VERIFIED 07/15/05}
BEGIN                   {02/10/07: Changed edit range to -8000 to 32000.}
  TWEdit.Strength:=
  PromptNum(0,0,'Enter Strength Points (-8000 to 32000)?',' Strength Points Change ',TWEdit.Strength,-8000,32000,True);

  WRITE_WOLVES_FILE;
  CwriteXY(25,9,Replicate(13,' '));   {Covers use of commas}
  CwriteXY(25,9,Get(Strength));
END;


{ 8  }PROCEDURE Do_Defense;              {VERIFIED 07/15/05}
BEGIN
  TWEdit.Defense:=       {02/10/07: Changed edit range to -8000 to 32000.}
  PromptNum(0,0,'Enter Defense Points (-8000 to 32000)?',' Defense Points Change ',TWEdit.Defense,-8000,32000,True);

  WRITE_WOLVES_FILE;
  CwriteXY(25,10,Replicate(11,' '));   {Covers use of commas with 200 Million amount.}
  CwriteXY(25,10,Get(Defense));
END;


{ 9  }PROCEDURE Do_Charm;               {VERIFIED 07/15/05}
BEGIN
  TWEdit.Charm:=           {02/10/07: Changed edit range to -8000 to 32000.}
  PromptNum(0,0,'Enter Charm Points (-8000 to 32000)?',' Charm Points Change ',TWEdit.Charm,-8000,32000,True);

  WRITE_WOLVES_FILE;
  CwriteXY(25,11,Replicate(6,' '));
  CwriteXY(25,11,Get(Charm));
END;


{ 0 }PROCEDURE Do_Gems;                 {VERIFIED 07/15/05}
BEGIN
  TWEdit.Gems:=
  PromptNum(0,0,'Enter Gems Stolen (0-32000)?',' Gems Stolen Change ',TWEdit.Gems,0,32000,True);

  WRITE_WOLVES_FILE;
  CwriteXY(57,11,Replicate(6,' '));
  CwriteXY(57,11,Get(Gems));
END;


{ A}PROCEDURE Do_Kids_Killed;            {VERIFIED 07/15/05}
BEGIN
  TWEdit.Kids_Killed:=
  PromptNum(0,0,'Enter # of Kids Killed (0-32000)?',' Kids Killed Change ',TWEdit.Kids_Killed,0,32000,True);

  WRITE_WOLVES_FILE;
  CwriteXY(25,12,Replicate(9,' '));    {Covers use of commas}
  CwriteXY(25,12,Get(Kids_Killed));
END;


{ B  }PROCEDURE Do_Horse_Kills;           {VERIFIED 07/15/05}
BEGIN
  TWEdit.Horse_Kills:=
  PromptNum(0,0,'Enter # of Horse Kills (0-32000)?',' Horses Killed Change ',TWEdit.Horse_Kills,0,32000,True);

  WRITE_WOLVES_FILE;
  CwriteXY(57,12,Replicate(5,' '));
  CwriteXY(57,12,Get(Horse_Kills));
END;


{ C }PROCEDURE Do_Human_Kills;             {VERIFIED 07/15/05}
BEGIN
  TWEdit.Human_Kills:=
   PromptNum(0,0,'Enter # of Warriors Killed (0-32000)?',' Warriors Killed Change ',TWEdit.Human_Kills,0,32000,True);

  WRITE_WOLVES_FILE;
  CwriteXY(25,13,Replicate(5,' '));
  CwriteXY(25,13,Get(Human_Kills));
END;


{ D }PROCEDURE Do_Attacks;              {VERIFIED 07/15/05}
BEGIN
  TWEdit.Attacks:=
   PromptNum(0,0,'Enter # of Attacks Today (0-32000)?',' Attacks Change ',TWEdit.Attacks,0,32000,True);

  WRITE_WOLVES_FILE;
  CwriteXY(57,13,Replicate(7,' '));  {included room for two blank spaces at end. }
  CwriteXY(57,13,Get(Attacks));
END;


{ ------------------- Used only by WOLFPLAY.DAT editor: ------------ }
{ E }PROCEDURE Do_Fairy_Rescue;  {Coded 02/10/07}    {verified 02/10/07}
BEGIN
  IF TWEdit.Fairy_Rescue = TRUE THEN TWEdit.Fairy_Rescue:= FALSE
    ELSE IF TWEdit.Fairy_Rescue = FALSE
           THEN TWEdit.Fairy_Rescue:= TRUE;

  WRITE_WOLVES_FILE;
  CwriteXY(28,14,Replicate(5,' '));
  CwriteXY(28,14,Get(Rescue));
END;


{ ===================== For WOLFCORP.DAT access ============ }

(*                            {12/27/05. Verified it worked, then disabled it. }
{ K }PROCEDURE Do_RecNum;                   {Created 12/27/05: VERIFIED 12/27/05}
BEGIN
  TCEdit.RecNum:=
   PromptNum(0,0,'Enter Corpse''s Record # (0-160)?',' Corpse Record Number Change ',TCEdit.RecNum,0,160,True);

  WRITE_CORPSES_FILE;
  CWriteXy(25,4,Replicate(5,' '));    { Allow room for 3 digits, and 2 blank spaces. }
  CWriteXy(25,4,Get2(RecNum));         { Write Record Number data, Line #6, column #2.}
END;         *)        {users are NOT allowed to change this value}


(*         {Like the RecNum field, this one will also be display-only.}
{ L }PROCEDURE Do_RealName2;       {Created 12/27/05: VERIFIED 12/27/05}
BEGIN
  TCEdit.RealName:=
   PromptStr(0,0,50,'Enter Corpse''s LORD REAL name',' Player Real Name Change ',TCEdit.RealName,False);

  WRITE_CORPSES_FILE;
  CWriteXy(25,4,Replicate(50,' '));  { Write data on position 25, Line #4. }
  CWriteXy(25,4,Get2(RealName2));
END;         *)    {users are NOT allowed to change this value}


{ M }PROCEDURE Do_LordName2;       {Created 12/27/05: VERIFIED 12/27/05}
BEGIN
  TCEdit.LordName:=
   PromptStr(0,0,20,'Enter Corpse''s LORD Name',' Player Lord Name Change ',TCEdit.LordName,False);

  WRITE_CORPSES_FILE;
  CwriteXY(25,5,Replicate(20,' '));
  CwriteXY(25,5,Get2(LordName2));     { Write data on position 25, Line #5. }
END;


{ N }PROCEDURE Do_Desecrations;     {Created 12/27/05: VERIFIED 12/27/05}
BEGIN
  TCEdit.Desecrations:=
   PromptNum(0,0,'Enter # of Desecrations Today (0-25)?',' Desecrations Change '
       ,TCEdit.Desecrations,0,25,True);

  WRITE_CORPSES_FILE;
  CWriteXy(25,6,Replicate(4,' '));    { Allow room for 2 digits, and 2 blank spaces. }
  CWriteXy(25,6,Get2(Desecrations));   { Write Desecrations data, Line #6, column #1. }
END;

{ ============== END of code block for WOLFCORP.DAT access }


{ note: To use Y, N responses via keyboard, one has to use
  the ALT key. Or simply use the mouse to click on the option wanted. }

FUNCTION  MaxPlayers: WORD; { Gets the number of customer records }   {VERIFIED 12/27/05}
BEGIN
  WolfPlay_FN:= IgmDir+WolfPlayer_FN;  {07/29/05}

  MaxPlayers:= 1;

  IF NOT Exist(WolfPlay_FN) THEN Exit;

  ASSIGN(Editor_File,WolfPlay_FN);
  LOCKFILE(WolfPlay_FN);
  RESET(Editor_File);

  MaxPlayers:= FileSize(Editor_File);

  UNLOCKFILE(WolfPlay_FN);
  CLOSE(Editor_File);
END;     { MaxPlayers  ============================================= }


FUNCTION GetRecordNum:STRING;     {Revised to include MaxPlayers data. VERIFIED 07/15/05}
BEGIN
  GetRecordNum:='`$'+N2S(RecordNum + 1)+' `%of `@'+N2S(MaxPlayers);
    { 08/30/05: Changed so that first record # displayed will be 1, not 0.}
END;     { GetRecordNum ---------------------------------------------- }


{ ============== For WOLFCORP.DAT access: 12/27/05 ============ }

 {Created 12/27/05: VERIFIED 12/27/05}
FUNCTION  MaxCorpses: WORD; { Gets the number of corpse records }
BEGIN
  Corpse_FN:= IgmDir+WolfCorpse_FN;

  MaxCorpses:=1;

  IF NOT Exist(Corpse_FN) THEN Exit;

  ASSIGN(Corpse_File,Corpse_FN);
  LOCKFILE(Corpse_FN);
  RESET(Corpse_File);

  MaxCorpses:= FileSize(Corpse_File);

  UNLOCKFILE(Corpse_FN);
  CLOSE(Corpse_File);
END;     { MaxCorpses  ====================================== }


FUNCTION GetCorpseNum:STRING;     {Created 12/27/05: VERIFIED 12/27/05}
BEGIN
  GetCorpseNum:='`$'+N2S(RecordNum + 1)+' `%of `@'+N2S(MaxCorpses);
    { First record # displayed will be 1, not 0.}
END;     { GetCorpseNum ------------------------------------ }


PROCEDURE ShowMenu;       {VERIFIED 12/27/05}
BEGIN
  ClrScr;    {11/30/06: added "Databases" to program name.}

  CWritelnC('`%** `@ Werewolf II Player Databases Editor `$'+Version+' `%**');  {Line 1}
  CWritelnC('`%WOLFPLAY.DAT Record Number: '+GetRecordNum);           {Line 2}
  CWriteLn(' ');

  { CwGotoXY, CWriteXY notes: X is position #, Y is line #. }

  CWGotoXY(3,4);   { Line 4 }
  CWriteLn('`2(`01`2) `!Real Name       `%: '+Get(RealName));  {Line 4}

  CWGotoXY(3,5);                 {Line 5}
  CWriteLn('`2(`02`2) `!LORD Name       `%: '+Get(LordName));

  CWGotoXY(3,6);                 {Line 6}
  CWrite('`2(`03`2) `!LORD Player #   `%: '+Get(PlayNum));

  CWGotoXY(38,6);                {Write at position 38.  }
  CWriteln('`2(`04`2) `!Visits Today `%: '+Get(Visits));

  CWGotoXY(3,7);
  CWriteLn('`2(`05`2) `!Wisdom Points   `%: '+Get(Wisdom));

  CWGotoXY(3,8);
  CWriteln('`2(`06`2) `!Max Hit-Points  `%: '+Get(HitMax));

  CWGotoXY(3,9);
  CWriteLn('`2(`07`2) `!Strength Points `%: '+Get(Strength));

  CWGotoXY(3,10);
  CWriteln('`2(`08`2) `!Defense Points  `%: '+Get(Defense));

  CWGotoXY(3,11);
  CWrite('`2(`09`2) `!Charm Points    `%: '+Get(Charm));

  CWGotoXY(38,11);
  CWriteln('`2(`%0`2) `!Gems Stolen  `%: '+Get(Gems));

  CWGotoXY(3,12);
  CWrite('`2(`%A`2) `!Kids Killed     `%: '+Get(Kids_Killed));

  CWGotoXY(38,12);
  CWriteln('`2(`%B`2) `!Horse Kills  `%: '+Get(Horse_Kills));

  CWGotoXY(3,13);
  CWrite('`2(`%C`2) `!Warrior Kills   `%: '+Get(Human_Kills));

  CWGotoXY(38,13);
  CWriteln('`2(`%D`2) `!Attacks Today`%: '+Get(Attacks));

  CWGotoXY(3,14);   {Added 02/10/07 using adapted SHADEDIT code}
  CWriteLN('`#(`%E`#) `!Rescued by Fairy? `%: '+Get(Rescue));     {verified 02/10/07}
  { -------------------------------------------- }

  CWriteLn(' ');  {Blank Line, Line #15.  }

  { Columns are aligned on-screen properly as of 2:59 am. 07/15/05 }
  { =========================================================== }

  { Adjusted following lines to use new positions 02/10/07 }
  { to account for new Fairy Rescue entry. }

  CWGotoXY(3,16);
  CWrite('`2(`0X`2) `%Search by Name');       {revised 08/25/05 to use X code.}

  CWGotoXY(40,16);
  CWriteln('`2(`0]`2) `%Advance to Next Record');     {revised 07/15/05}

  CWGotoXY(3,17);
  CWrite('`2(`0[`2) `%Back Up One Record');      {revised 07/15/05}

  CWGotoXY(40,17);
  CWriteln('`2(`0*`2) `%New Day For Player');

  CWriteLn(' ');  { Blank line. Line 18. 07/15/05 }

  CWGotoXY(3,19);
  Cwrite('`$    Input key to change, or `%Q `$to quit and save.');
END;     { ShowMenu  ================================================ }


PROCEDURE Show_Menu2;   {Created 12/27/05: VERIFIED 12/27/05}
BEGIN                    { for use ONLY with WOLFCORP.DAT }
  ClrScr;           {11/30/06: added "Database" to program name.}

  CWritelnC('`%** `@ Werewolf II Corpse Database Editor `%**');  {Line 1}
  CWritelnC('`%WOLFCORP.DAT Record Number: '+GetCorpseNum);           {Line 2}
  CWriteLn(' ');

  { CwGotoXY, CWriteXY notes: X is position #, Y is line #. }

  CWGotoXY(3,4);   { Lines 4,5,6, and 7 }
  CWriteLn('`$(`0K`$) `!Corpse Record #  `%: '+Get2(RecNum));  {Line 4}

  CWGotoXY(3,5);
  CWriteLn('`$(`0L`$) `!Corpse Real Name `%: '+Get2(RealName2));

  CWGotoXY(3,6);
  CWriteLn('`$(`0M`$) `!Corpse LORD Name `%: '+Get2(LordName2));

  CWGotoXY(3,7);
  CWriteln('`$(`0N`$) `!# of Desecrations`%: '+Get2(Desecrations));

  CWGotoXY(3,8);
  CWriteLn(' ');  {Blank Line, Line #8. }

  CWGotoXY(3,9);
  CWriteLn('  `#NOTES:  `0You may change ONLY the LORD Name and Desecrations ');

  CWGotoXY(3,10);
  CWriteLn('  `0values.  The other values are display-only.  They are used  ');

  CWGotoXY(3,11);
  CWriteLn('  `0by the IGM to correctly identify a corpse for desecration. ');

  CWGotoXY(3,12);
  CWriteLn(' ');   {Blank Line. Line 12}

  { =========================================================== }
  CWGotoXY(3,13);
  CWrite('`$(`0X`$) `%Search by Name');

  CWGotoXY(35,13);
  CWriteln('`$(`0]`$) `%Advance to Next Record');

  CWGotoXY(3,14);
  CWrite('`$(`0[`$) `%Back Up One Record');

  CWGotoXY(35,14);
  CWriteln('`$(`0*`$) `%Reset Desecration Counter');

  CWriteLn(' ');  { Blank line. Line 15 }

  CWGotoXY(3,16);
  Cwrite('`$    Input key to change, or `%Q `$to quit and save. `0');
END;     { Show_Menu2  ======================================= }


      { 02/28/07: Renamed DO_PlayerSearch to DO_PLAYER_SEARCH. }
{ X }PROCEDURE DO_PLAYER_SEARCH;            {VERIFIED 12/27/05}
VAR Counter, YN : BYTE;
    Temp, OTemp : STRING;

BEGIN
  WolfPlay_FN:= IgmDir+WolfPlayer_FN;  {07/29/05}

  IF NOT Exist(WolfPlay_FN) THEN Exit;
     { if no WOLFPLAY.DAT then we can't search and
       couldn't have made it here to begin with. }

  Counter:= 0;
  Temp:= PromptStr(0,0,50,' Enter full or partial name: ',' Player Search ','',False);
  OTemp:= Temp;
  Temp:= S2U(Temp);  { upcase the whole string }

  REPEAT
    SEARCH_PLAYER(Counter);    {12/27/05: renamed SEARCH to SEARCH_PLAYER}

    { This next evaluation is checking to see if TEMP exists anywhere in
      either field of record.  If YES, then execute the next section,
      otherwise increment counter and move on.  Note: Using FUNCTION NoColor
      to strip Lord color codes for string eval and display. }

       { 09/01/05: renamed Real_Names to RealName. }
    IF (POS(Temp,S2U(TSearch.LordName))>0) OR (POS(Temp,NoColor(S2U(TSearch.RealName)))>0) THEN
      BEGIN
        YN:= PromptYesNo('','Are you looking for:|'+TSearch.LordName+' known as '+NoColor(TSearch.RealName)+'?');

        IF YN=1 THEN {1 means YES answer}
          BEGIN
            RecordNum:= Counter; { LORD Player # to display matches the counter }

            READ_WOLVES_FILE;
            ShowMenu;
            Exit; { bail out of loop since we got who we want }
          END;
      END;
    Inc(Counter);
  UNTIL Counter=MaxPlayers; { End of repeat loop, repeats until we get
										to last player record. }

  { if we make it to here, then there were no matches. }

  PromptOK(' Search Error! ','No match found for '+OTemp+'!');  {02/11/04}
END;       { =============================================== }


{ X }PROCEDURE Do_Corpse_Search;     {Created 12/27/05}
VAR Counter2, YesNo : BYTE;
    Temp2, OTemp2 : STRING;

BEGIN
  Corpse_FN:= IgmDir+WolfCorpse_FN;

  IF NOT Exist(Corpse_FN) THEN Exit;
     { if no WOLFCORP.DAT then we can't search and
       couldn't have made it here to begin with. }

  Counter2:= 0;
  Temp2:= PromptStr(0,0,50,' Enter full or partial name: ',' Corpse Search ','',False);

  OTemp2:= Temp2;
  Temp2:= S2U(Temp2);  { upcase the whole string }

  REPEAT
    Search_Corpses(Counter2);

    { This next evaluation is checking to see if Temp2 exists anywhere in
      either field of record.  If YES, then execute the next section,
      otherwise increment Counter2 and move on.  Note: Using FUNCTION NoColor
      to strip Lord color codes for string eval and display. }

    IF (POS(Temp2,S2U(TSearch2.LordName))>0) OR (POS(Temp2,NoColor(S2U(TSearch2.RealName)))>0) THEN
      BEGIN
        YesNo:= PromptYesNo('','Are you looking for:|'+TSearch2.LordName+' known as '+NoColor(TSearch2.RealName)+'?');

        IF YesNo=1 THEN {1 means YES answer}
          BEGIN
            Corpse_Number:= Counter2; { LORD Player # to display matches the Counter2 }

            READ_CORPSES_FILE;

            SHOW_MENU2;

            EXIT; { bail out of loop since we got who we want }
          END;
      END;
    Inc(Counter2);
  UNTIL Counter2=MaxCorpses;
     { End of repeat loop, repeats until we get }
     { to the last desecrations file record. }

  { if we make it to here, then there were no matches. }

  PromptOK(' Corpse Search Error! ','No match found for '+OTemp2+'!');
END;       { =============================================== }


{ * }PROCEDURE Do_NewDay;             {VERIFIED 09/28/05}
BEGIN
  CWGotoXY(5,24);
  CWriteLn('  `0Running `%"Do New Day for Player" `0process. 3-second delay.');
  DELAY(3000);
  { ======================================================================= }

  { -----------------  Rewrote 02/28/07 --------------------- }
  { Note: PlayNum is a BYTE variable field which can't be set }
  { in normal program usage to a negative number.  Insurance  }
  { code added to cover situation just in case it is needed.  }

  IF (TWEdit.PlayNum < 0) OR (TWEdit.PlayNum > 160) THEN
    BEGIN
      TWEdit.PlayNum:= 160;

      PromptOK('Advisory:',' Resetting invalid LORD Player # field to 160. |'
                 +'The IGM will correct the field to its correct value when |'
                 +'it runs its New Day Maintenance process. ');
                   {edited 02/28/07: verified 09/29/07}
    END;
        
      { --------------------------------------------------- }
  IF TWEdit.Visits > 0 THEN          {VERIFIED}
    BEGIN
      TWEdit.Visits:= 0;
      PromptOK('Advisory:',' Resetting the Visits field to 0.');
    END;

  { --------------------------------------------------- }
  IF TWEdit.HitMax < 0 THEN          {VERIFIED}
    BEGIN
      TWEdit.HitMax:= 0;
      PromptOK('Advisory:',' Reset negative Max Hit-Points field to 0.');
    END;

  IF TWEdit.HitMax > 0 THEN          {VERIFIED}
    BEGIN
      TWEdit.HitMax:= 0;
      PromptOK('Advisory:',' Resetting the Max Hit-Points field to 0.');
    END;

  { --------------------------------------------------- }
  IF TWEdit.Strength < 0 THEN        {VERIFIED}
    BEGIN
      TWEdit.Strength:= 0;
      PromptOK('Advisory:',' Reset negative Strength Points field to 0.');
    END;

  IF TWEdit.Strength > 0 THEN        {VERIFIED}
    BEGIN
      TWEdit.Strength:= 0;
      PromptOK('Advisory:',' Resetting the Strength Points field to 0.');
    END;

  { --------------------------------------------------- }
  IF TWEdit.Defense < 0 THEN         {VERIFIED}
    BEGIN
      TWEdit.Defense:= 0;
      PromptOK('Advisory:',' Reset negative Defense Points field to 0.');
    END;

  IF TWEdit.Defense > 0 THEN         {VERIFIED}
    BEGIN
      TWEdit.Defense:= 0;
      PromptOK('Advisory:',' Resetting the Defense Points field to 0.');
    END;

  { --------------------------------------------------- }
  IF TWEdit.Charm < 0 THEN           {VERIFIED}
    BEGIN
      TWEdit.Charm:= 0;
      PromptOK('Advisory:',' Reset negative Charm Points field to 0.');
    END;

  IF TWEdit.Charm > 0 THEN           {VERIFIED}
    BEGIN
      TWEdit.Charm:= 0;
      PromptOK('Advisory:',' Resetting the Charm Points field to 0.');
    END;

  { ------------------------------------------------- }
  IF TWEdit.Gems < 0 THEN            {VERIFIED}
    BEGIN
      TWEdit.Gems:= 0;
      PromptOK('Advisory:',' Reset negative Gems field to 0.');
    END;

  IF TWEdit.Gems > 0 THEN            {VERIFIED}
    BEGIN
      TWEdit.Gems:= 0;
      PromptOK('Advisory:',' Resetting the Gems field to 0.');
    END;

  { --------------------------------------------------- }
  IF TWEdit.Wisdom < 0 THEN          {VERIFIED}
    BEGIN
      TWEdit.Wisdom:= 0;
      PromptOK('Advisory:',' Reset negative Wisdom Points field to 0.');
    END;

  IF TWEdit.Wisdom > 0 THEN          {VERIFIED}
    BEGIN
      TWEdit.Wisdom:= 0;
      PromptOK('Advisory:',' Resetting the Wisdom Points field to 0.');
    END;

  { Notes: PlayNum, Visits are BYTE format, so }
  { they can't be set to negative values. }

  { ==================================================- }
  IF TWEdit.Kids_Killed < 0 THEN
    BEGIN
      TWEdit.Kids_Killed:= 0;
      PromptOK('Advisory:',' Reset negative Kids Killed field to Zero.');
    END;

  IF TWEdit.Kids_Killed > 0 THEN
    BEGIN
      TWEdit.Kids_Killed:= 0;
      PromptOK('Advisory:',' Resetting the Kids Killed field to Zero.');
    END;

  { ==================================================- }
  IF TWEdit.Horse_Kills < 0 THEN
    BEGIN
      TWEdit.Horse_Kills:= 0;
      PromptOK('Advisory:',' Reset negative Horses Killed field to Zero.');
    END;

  IF TWEdit.Horse_Kills > 0 THEN
    BEGIN
      TWEdit.Horse_Kills:= 0;
      PromptOK('Advisory:',' Resetting the Horses Killed field to Zero.');
    END;

  { ==================================================- }
  IF TWEdit.Human_Kills < 0 THEN
    BEGIN
      TWEdit.Human_Kills:= 0;
      PromptOK('Advisory:',' Reset negative Warriors Killed field to Zero.');
    END;

  IF TWEdit.Human_Kills > 0 THEN
    BEGIN
      TWEdit.Human_Kills:= 0;
      PromptOK('Advisory:',' Resetting the Warriors Killed field to Zero.');
    END;

      { ==================================================- }
  IF TWEdit.Attacks < 0 THEN
    BEGIN
      TWEdit.Attacks:= 0;
      PromptOK('Advisory:',' Reset negative Attacks Today field to Zero.');
    END;

  IF TWEdit.Attacks > 0 THEN
    BEGIN
      TWEdit.Attacks:= 0;
      PromptOK('Advisory:',' Resetting the Attacks Today field to Zero.');
    END;

  TWEdit.Fairy_Rescue:= FALSE;  {Boolean}  {Added 02/10/07}

  ShowMenu;

  WRITE_WOLVES_FILE;
END;     { Do_NewDay  ======================================= }


         {CREATED 12/27/05 for WOLFCORP.DAT access}

{ * }PROCEDURE Do_NewDay2;
BEGIN
  CWGotoXY(5,24);
  CWriteLn('  `0Running `%"Reset Corpse Values" `0process. 3-second delay.');
  DELAY(3000);
  { ======================================================================= }

      { --------------------------------------------------- }
  IF TCEdit.Desecrations > 0 THEN
    BEGIN
      TCEdit.Desecrations:= 0;
      PromptOK('Advisory:',' Resetting the Desecrations field to 0.');
    END;

  SHOW_MENU2;

  WRITE_CORPSES_FILE;
END;     { Do_NewDay2  ======================================= }


PROCEDURE RUN_WOLFPLAY_EDITOR;
  VAR Wolf_Code: CHAR;  {03/08/06: Renamed CH VAR to Wolf_Code.}
BEGIN
  ShowMenu;

  REPEAT
    Wolf_Code:= AInput('1234567890ABCDEQX][*');  {08/25/05: Changed Y to X.}
                              {02/10/07: Added E code.}
    CASE Wolf_Code OF
      '1' : Do_RealName;

      '2' : Do_LordName;

      '3' : BEGIN
              CWGotoXY(1,24);
              { -------- Edited color codes 02/28/07 --------- }
              CWriteLn('  `0The `$LORD Player Number `0field is display-only.  I don''t see ');
              CWriteLn('  `0a valid reason to allow it to be edited.  `%3-second delay. ');
              DELAY(3000);

              { ----------- Added from ROL2EDIT 02/28/07 ------- }
              IF DebugVar THEN
                BEGIN
                  BLANK(1);
                  CWriteLn('  `0Usage of `!/DEBUG `0parameter was detected, so user is ');
                  CWriteLn('  `0allowed to modify the Player Number field.  Do so with ');
                  CWriteLn('  `@CAUTION `0because it is a `@VERY `0important database field.');
                  DELAY(3000);

                  DO_PLAYER_NUMBER;
                END;

              { 02/28/07: Renamed DO_PlayNum to DO_PLAYER_NUMBER. }
              { ------------------------------------------------ }

              ShowMenu;
            END;

      '4' : Do_Visits;

      '5' : Do_Wisdom;
      '6' : Do_HitMax;

      '7' : Do_Strength;
      '8' : Do_Defense;

      '9' : Do_Charm;
      '0' : Do_Gems;

      'A' : Do_Kids_Killed;
      'B' : Do_Horse_Kills;

      'C' : Do_Human_Kills;
      'D' : Do_Attacks;

      'E' : Do_Fairy_Rescue;      {Added 02/10/07}   {verified 02/10/07}

      'X' : DO_PLAYER_SEARCH;  { 07/15/05: Deleted DoPlayerDelete process. }
                               { 11/04/05: Renamed DoPlayerSearch to Do_PLayerSearch. }
                 { 02/28/07: Renamed DO_PlayerSearch to DO_PLAYER_SEARCH. }

      ']' : BEGIN
              Inc(RecordNum);
              IF RecordNum > (MaxPlayers - 1) THEN RecordNum:= 0;  {02/14/04 edit}

              READ_WOLVES_FILE;
              ShowMenu;
            END;

      '[' : BEGIN
              IF RecordNum=0 THEN RecordNum:= (MaxPlayers - 1)
                             ELSE Dec(RecordNum);
              READ_WOLVES_FILE;
              ShowMenu;
            END;

      '*' : Do_NewDay;
    END;       {CASE Wolf_Code - ending}
  UNTIL Wolf_Code = 'Q';
END;       { RUN_WOLFPLAY_EDITOR ======================================================= }


PROCEDURE RUN_WOLFCORP_EDITOR;  {CREATED 12/27/05: VERIFIED 12/27/05}
  VAR Corpse_Code: CHAR;  {03/08/06: Renamed CH VAR to Corpse_Code.}
BEGIN
  SHOW_MENU2;

  REPEAT
    Corpse_Code:= AInput('KLMNQX][*');

    CASE Corpse_Code OF
      'K' : BEGIN                  {Verified 12/27/05}
              CWGotoXY(1,24);
              CWriteLn('  `0The `#Corpse Record Number `0field is display-only.  I don''t see ');
              CWriteLn('  `0a valid reason to allow it to be edited.  3-second delay. ');
              DELAY(3000);

              (*  Do_RecNum;   {Enabled for testing purposes only}  *)  {Disabled 12/27/05 9:55 pm}

              SHOW_MENU2;
            END;

      'L' : BEGIN                  {Verified 12/27/05}
              CWGotoXY(1,24);
              CWriteLn('  `0The Corpse''s LORD Real Name field is display-only.  I don''t see ');
              CWriteLn('  `0a valid reason to allow it to be edited.  3-second delay. ');
              DELAY(3000);

              (*  Do_RealName2;   {Enabled for testing purposes only}  *)  {Disabled 12/27/05 10:04 pm}

              SHOW_MENU2;
            END;

      'M' : BEGIN  Do_LordName2;      SHOW_MENU2;    END;   {Verified 12/27/05}

      'N' : BEGIN  Do_Desecrations;   SHOW_MENU2;    END;   {Verified 12/27/05}

      'X' : Do_Corpse_Search;          {VERIFIED}

      ']' : BEGIN
              Inc(Corpse_Number);         {VERIFIED}
              IF Corpse_Number > (MaxCorpses - 1) THEN Corpse_Number:= 0;  {02/14/04 edit}

              READ_CORPSES_FILE;       {verified}

              SHOW_MENU2;
            END;

      '[' : BEGIN                  {VERIFIED}
              IF Corpse_Number=0 THEN Corpse_Number:= (MaxCorpses - 1)
                                 ELSE Dec(Corpse_Number);
              READ_CORPSES_FILE;

              SHOW_MENU2;
            END;

      '*' : Do_NewDay2;        {VERIFIED 12/27/05}
    END;       {CASE Corpse_Code - ending}
  UNTIL Corpse_Code = 'Q';

  BLANK(1);      {12/27/05}
END;     { Run_WolfCorp_Editor ======================================= }


PROCEDURE LOCAL_PAUSE;
	VAR c: CHAR;
BEGIN
  CWrite('`!<MORE>');
  c:= ReadKey;    { DOS utility programs have to use ReadKey. }
  BLANK(1);
END; { LOCAL_PAUSE ==================== }


PROCEDURE DISPLAY_MENU_CODE(MenuCode: CHAR);  {Created 06/07/04}
BEGIN
  CWriteLn('  `0'+MenuCode);  { Show Menu Code used on-screen }
  DELAY(1500);
END;  {DISPLAY_MENU_CODE ================================ }


PROCEDURE EXIT_SCREEN;
  VAR Editor_Path: STRING;
BEGIN
  { the | character will cause a linefeed, I forget what max chars
    are.  Anyhow, say whatever you want here or remove it totally }

  IF Editor_Code = 1               {added 12/27/05}
    THEN Editor_Path:= WolfPlay_FN;        {Display WOLFPLAY.DAT file path info}

  IF Editor_Code = 2               {added 12/27/05}
    THEN Editor_Path:= Corpse_FN;     {Display WOLFCORP.DAT file path info}

  IF Editor_Code = 3               {added 12/27/05}
    THEN Editor_Path:= ProgPath;      {Display Path for WOLFEDIT.exe}

       {11/30/06: added "Player" to program name.}
  PromptOK(' WereWolf II Player Databases Editor Credits: ',
      'WOLFEDIT.EXE '+Version+'.  Copyright 2005-2007 by Donald Tidmore. |'

      +'** Dedicated to my friend Jay Hodges. ||'

      {  +'Compile Date:  '+Compile_Date+'  ** Released on 10/24/2007. ||'  }
         {06/06/07: Added ending period to Compile_Date constant.}

      +'Released officially on:  '+Release_Date+' ||'   {Enabled 10/23/07}

      +'Database Path: '+Editor_Path);      {Added 4th line on 08/12/05}
          {12/01/06: Changed "Utility Path" to "IGM Path".}
          { 09/29/07: Changed "IGM Path" to "Database Path".}
END; { EXIT_SCREEN ============================================ }


PROCEDURE SELECT_DATABASE;  { Created proc. 12/27/2005 }
  CONST DashLine = '  `$====================================================================';
         { 70 spaces long, including 2 blank spaces. }

  LABEL Redo_Selection;
BEGIN
  Redo_Selection:  {LABEL: 12/27/05}
  { ------------------------------ }

  BLANK(1);
  CWriteLn('      `$WOLFEDIT `!IGM Databases Selection Menu');
  CWriteLn(DashLine);
  BLANK(1);

  CWriteLn('  `@(`$1`@) `!Edit IGM Player Database');

  CWriteLn('  `@(`$2`@) `!Edit Desecrations Database ');

  CWriteLn('  `@(`$3,Q`@) `!Quit using `@WOLFEDIT.EXE');
  BLANK(1);                            {06/01/06: Show WOLFEDIT.EXE in Red.}

  Editor_Code:= 1;  {Default setting}

  CWrite('  `0Which option do you want? `!(123Q)`%: `$');

  CASE Ainput('123Q') OF
    '1': BEGIN
           DISPLAY_MENU_CODE('1');

           { ======== Moved to here 12/27/05: VERIFIED ======== }
           WolfPlay_FN:= IGMDir+WolfPlayer_FN;

           {User is running the IGM Player Database Editor. Editor_Code is 1.}

           IF Exist(WolfPlay_FN) THEN READ_WOLVES_FILE   {08/12/05 code block}
           ELSE
             BEGIN
               BLANK(1);
               CWriteLn('  `@ERROR:  `0WOLFEDIT `!could not locate `@Werewolf II''s ');
               CWriteLn('  `%WOLFPLAY.DAT `!file, which is `%REQUIRED `!for you to edit ');
               CWriteLn('  `!the IGM''s database records.');  {Edited 06/01/06}

               BLANK(1);
               CWriteLn('  `0WOLFEDIT `!looked for this file, which was not found: ');
               CWriteLn('    `$'+WolfPlay_FN);

               BLANK(1);
               CWriteLn('  `!Returning you to the `0Selection Menu. ');
               BLANK(1);

               LOCAL_PAUSE;

               ClrScr;

               GOTO Redo_Selection;
             END;
           { ================================================ }

           BLANK(1);
           CWriteLn('    `!Running Player Database Editor in 3 seconds');
           DELAY(3000);

           RUN_WOLFPLAY_EDITOR;

           BLANK(2);   {12/01/06: changed to 2 blank lines. both are needed here.}

           LOCAL_PAUSE;   {02/10/07. needed here}
           ClrScr;        {02/10/07. needed here}

           CWriteLn('  `!Returning you to the `#Editors Selection Menu `!in `$3 `!seconds.');  {06/25/06}
           DELAY(3000);  {06/25/06}

           GOTO Redo_Selection;  {Added so program returns to Selection Menu 06/25/06}
         END;

    '2': BEGIN
           DISPLAY_MENU_CODE('2');

           { ======== Added 12/27/2005: VERIFIED ========== }
           Corpse_FN:= IGMDir+WolfCorpse_FN;

           Editor_Code:= 2;  {User is running the IGM Corpses Database Editor.}

           IF Exist(Corpse_FN) THEN READ_CORPSES_FILE
           ELSE
             BEGIN                    {Re-verified 06/01/06}
               CWriteLn(' ');
               CWriteLn('  `@ERROR:  `0WOLFEDIT `!could not locate `@Werewolf II''s ');
               CWriteLn('  `%WOLFCORP.DAT `!file, which is `%REQUIRED `!for you to edit ');
               CWriteLn('  `!the IGM''s `0Desecrations Database `!records.');
                                            {Edited 06/01/06}
               BLANK(1);
               CWriteLn('  `0WOLFEDIT `!looked for this file, which was not found: ');
               CWriteLn('    `$'+Corpse_FN);

               BLANK(1);        {06/01/06: Added blank line, 3 statement lines: VERIFIED}
               CWriteLn('  `%NOTE: `0The file does not exist until at least one warrior is ');
               CWriteLn('  `#DEAD `0in `@LORD, `0and a Werewolf has to have `@Desecrated `0at least');
               CWriteLn('  `%ONE `0corpse in the IGM today.');
                                    {Wording layout verified 06/01/06 01:18 pm}
               BLANK(1);
               CWriteLn('  `!Returning you to the `0Selection Menu. ');
               BLANK(1);

               LOCAL_PAUSE;

               ClrScr;

               GOTO Redo_Selection;
             END;
            { ================================================ }

           BLANK(1);
           CWriteLn('    `!Running Desecrations Database Editor in 3 seconds');
           CWriteLn('    `@WARNING: `!This is brand new, and will possibly be buggy.');
           DELAY(3000);

           RUN_WOLFCORP_EDITOR;

           BLANK(2);   {12/01/06: changed to 2 blank lines. both are needed here.}

           LOCAL_PAUSE;   {02/10/07. needed here}
           ClrScr;        {02/10/07. needed here}

           CWriteLn('  `!Returning you to the `#Editors Selection Menu `!in `$3 `!seconds.');  {06/25/06}

           DELAY(3000);  {06/25/06}

           GOTO Redo_Selection;  {Added so program returns to Selection Menu 06/25/06}
         END;

    '3',                    {added Q key usage support 02/10/07}
    'Q': BEGIN
           DISPLAY_MENU_CODE('3');

           Editor_Code:= 3;

           BLANK(1);
           CWriteLn('    `!Exiting WOLFEDIT Utility now.');
         END;
   END;  {CASE Main Menu options}

  DELAY(2000);

  EXIT_SCREEN;

END;  { SELECT_DATABASE ==================================== }


BEGIN    { Main WOLFEDIT.pas BEGIN/END structure }
  ClrScr;
  CursorOff;                  {Gold toolkit process}

  UseLordColors:= True;

  DebugVar:= FALSE;   {Added 02/28/07}

  IF S2U(ParamStr(1)) = '/DEBUG'  {Added 02/28/07}
    THEN DebugVar:= TRUE;

  ReadVars.ReadHelp:= NIL;  { removes the HELP button in the prompts. }   {Gold toolkit process}

  WinNoClose:= True;        { removes the prompt window close
                             button in upper left. }      {Gold toolkit process}

  ProgPath:= Copy(ParamStr(0),1,Length(ParamStr(0))-12);   {Added 07/15/05: Verified usage}
            { deducts 12 spaces to remove WOLFEDIT.EXE from data string. }

  RecordNum:= 0;   {used with WOLFPLAY.DAT}

  Corpse_Number:= 0;  {Used with WOLFCORP.DAT}

  ReadConfig;

  SELECT_DATABASE;  {Added 12/27/05: VERIFIED}

  ResetStartUpMode;     {Gold toolkit process}
END. { WOLFEDIT.pas }

    { Started creation using KLBEdit code 07/14/2005. }
    { Eliminated usage of Wolfunit.pas file on 08/25/2005. }

    { Finished development, and released v1.00 officially on 12/01/2006. }
    { ======================================================== }

{04/28/07: Changed 1.02 to v1.05}

